# -*- coding: utf-8 -*-
# Algorithmus_von_Prim_Schritte.py

import time

from Graphenprojekt import *
cont=Controller()

graph=cont.gibKantenDict()
print(graph)

### kleiner Graph:
### Knotenliste muss beide Richtungen beinhalten!
##graph={'A': [['B', '27'], ['E', '18']],
##       'B': [['A', '27'], ['C', '12'], ['F', '12']],
##       'C': [['B', '12'], ['D', '18'], ['F', '16']],
##       'D': [['C', '18'], ['E', '36'], ['F', '16']],
##       'E': [['A', '18'], ['D', '36'], ['F', '25']],
##       'F': [['B', '12'], ['C', '16'], ['D', '16'], ['E', '25']]
##    }

# ----- kuerzer -----
def kuerzer(kante1, kante2):
    return  (kante1[2] < kante2[2])

# ----- ordneEin -----
# sortiert durch Einfügen
def ordneEin(kante, sortierte):
    for index in range(len(sortierte)):
        if kuerzer(kante, sortierte[index]):
            sortierte[index:index]=[kante]
            return sortierte
    sortierte[len(sortierte):len(sortierte)]=[kante]
    return sortierte

def nachfolgeKanten(knoten, graph):
    kanten=[]
    nachfolger=graph[knoten]
    for nach in nachfolger:
        kanten+=[[knoten]+nach]
    return kanten

# ----- Der eigentliche Algorithmus -----
# Schrittfunktion für die schrittweise Darstellung
def AvPrimSchritt(baum,enthaltene,graph,neuer,prioWS):
    if len(enthaltene)<len(graph):
        print( '\nDer Baum ist bisher:', baum )
        print( 'Neuer Knoten ist:', neuer )
        if len(baum)==0:
            cont.aendereFuellFarbe(Knoten,neuer,'red')
        for kante in nachfolgeKanten(neuer, graph):
            print( 'Die Kante in PrioSchlange einfügen:', kante )
            prioSchlange=ordneEin(kante, prioWS)
        print( 'PrioSchlange ist jetzt:', prioWS )
        # Entferne alle Zyklen:
        temp=[]
        for kante in prioWS:
            print( 'Zyklentest der Kante', kante )
            if not (kante[0] in enthaltene):
                temp.append(kante)
            elif not (kante[1] in enthaltene):
                temp.append(kante)
            elif enthaeltRueckKante(baum, kante):
                print('Kante ist Rueckkante')
            else:
                # kante bildet Zyklus
                print(kante,' erzeugt einen Zyklus' )
                cont.aendereRandFarbe(Kante,kante[0],
                                      'gray',kante[1])        
        prioWS=temp
        # Die erste Kante setzt den Baum minimal fort
        print( 'Die erste Kante kann eingebaut werden:',prioWS[0] )
        baum.append(prioWS[0])
        cont.aendereRandFarbe(Kante,prioWS[0][0],'blue',
                              prioWS[0][1])
        if prioWS[0][0] in enthaltene:
            enthaltene.append(prioWS[0][1])
            neuer=prioWS[0][1]
        else:
            enthaltene.append(prioWS[0][0])
            neuer=prioWS[0][0]
        print( 'Neuer Knoten ist:', neuer )
        print( 'Baum:', baum )
        cont.aendereFuellFarbe(Knoten,neuer,'red')
        #input('Knoten'+neuerKnoten)
        prioWS.remove(prioWS[0])
        print( 'PrioSchlange ist jetzt:', prioWS )
    else:
        for element in prioWS:
            cont.aendereRandFarbe(Kante,element[0],'gray',element[1])
        print('\nfertig!\nLösung ist:')
        print(baum)
    return baum,enthaltene,graph,neuer,prioWS

def enthaeltRueckKante(baum, dieKante):
    for kante in baum:
        if kante[0]==dieKante[1] and kante[1]==dieKante[0]:
            return True
    return False


### ===== Testaufruf =====
baum=[]
enthaltene=['A']
neuer='A'
prioWS=[]

### ===== Ablauf darstellen =============
# geben Sie nach dem Start von start.py
# wiederholt die folgende Anweisung in der Shell ein:
##baum,enthaltene,graph,neuer,prioWS=AvPrimSchritt(baum,enthaltene,graph,neuer,prioWS)
print('wiederholt eingeben:')
print('baum,enthaltene,graph,neuer,prioWS=AvPrimSchritt(baum,enthaltene,graph,neuer,prioWS)')

### ----- Laenge bestimmen: -----
##def laengeKanten(baum):
##    if kanten==[]: return 0
##    return kanten[0][2]+laengeKanten(kanten[1:])
##print( laengeKanten(AvPrim(mustergraph, 1)) )
